
# this will create COMDLGS.LIB, an OMF library for emulation of COMDLG32.

# to create enter "nmake /f text.mak"

# Please note: paths in file "..\dirs" have to be adjusted first!

# to create a debug version use "nmake /f text.mak debug=1"
# the debug modules will be located in directory TEXTD,
# which probably has to be created first!

# if MASM version >= 7.00 is used, option -omf has to be placed
# behind ml in ASM variable

!include <..\dirs>

!ifndef DEBUG
DEBUG=0
!endif

!if $(DEBUG)
AOPTD=-D_DEBUG
OUTDIR=TEXTD
!else
AOPTD=
OUTDIR=TEXT
!endif

NAME=COMDLGS

SRCMODS = \
!include modules.inc

OBJNAMES= $(SRCMODS:.ASM=.OBJ)
OBJMODS = $(OBJNAMES:.\=TEXT\)

ASMOPT= -c -nologo -Sg $(AOPTD) -I$(INC32DIR)
ASM=ml.exe $(ASMOPT) -D?FLAT=0 -Fl$* -Fo$*

.SUFFIXES: .asm .obj

.asm{$(OUTDIR)}.obj:
    $(ASM) $<

$(OUTDIR)\$(NAME).LIB: $(OBJMODS) $(OUTDIR)\comdlg32.obj
	@cd $(OUTDIR)
    @del $(NAME).lib
    $(LIB16BIN) /NOLOGO $(NAME).LIB @<<
$(OBJNAMES:.\=+), $(NAME).;
<<
	@cd ..
!if $(DEBUG)==0
#	copy $*.LIB $(LIBOMF)\*.*
!endif    

clean:
    @del $(OUTDIR)\*.obj
    @del $(OUTDIR)\*.lib
    @del $(OUTDIR)\*.map
    @del $(OUTDIR)\*.lst
