
# this will create DKRNL32S.LIB with all modules in OMF format.

# support for segmented models has been abandoned since v3.2,
# this makefile will now create the FLAT version of all modules.

# to create enter "nmake /f omf.mak"

# Please note: paths in file "..\dirs" have to be adjusted first!

# to create a debug version use "nmake /f omf.mak debug=1"
# the debug modules will be located in directory OMFD,
# which probably has to be created first!

# The MS OMF lib tool ist used here, renamed to LIB16.EXE!

# if MASM version >= 7.00 is used, option -omf has to be placed
# behind ml in ASM variable

!include <..\dirs>

!ifndef DEBUG
DEBUG=0
!endif

!if $(DEBUG)
AOPTD=-D_DEBUG
OUTDIR=OMFD
!else
AOPTD=
OUTDIR=OMF
!endif

NAME=DKRNL32S

SRCMODS = \
!include modules.inc

OTHERMODS=.\int21lfn.obj

OBJNAMES= $(SRCMODS:.ASM=.OBJ)
OBJMODS = $(OBJNAMES:.\=OMF\)

ASMOPT= -c -nologo -Cp -Sg -D_KERNEL32_=1 $(AOPTD) -I$(INC32DIR)
ASM=ml.exe $(ASMOPT) -D?FLAT=1 -Fl$* -Fo$*

LIBTOOLOMF=$(DMCDIR)\lib.exe

.SUFFIXES: .asm .obj

.asm{$(OUTDIR)}.obj:
    $(ASM) $<

#$(OBJNAMES:.\=+) $(OTHERMODS:.\=+), $(NAME).;

$(OUTDIR)\$(NAME).LIB: $(OBJMODS) OMF\int21lfn.obj
	@cd $(OUTDIR)
    if exist $(NAME).LIB del $(NAME).LIB
    $(LIBTOOLOMF) /c $(NAME).LIB @<<
$(OBJNAMES) $(OTHERMODS), $(NAME).;
<<
	@cd ..
!if $(DEBUG)==0
#	copy $*.LIB $(LIBOMF)\*.*
!endif    

$(OBJMODS): dkrnl32.inc

clean:
	@del $(OUTDIR)\*.obj
	@del $(OUTDIR)\*.lib
	@del $(OUTDIR)\*.lst
